#ifndef ReLUImpl_ref_cpp_forward_kernel_H_
#define ReLUImpl_ref_cpp_forward_kernel_H_

#include "utils/Registrar.hpp"

#include "operator/ReLUImpl.hpp"

namespace Aidge {
template <class I, class O>
void ReLUImpl_ref_cpp_forward_kernel(const ReLU_Op::Parameters& params,
                                     std::size_t inputLenght,
                                     const void* input_,
                                     void* output_) {
    // FIXME: missing ReLU parameters as arguments
    const I* input = static_cast<const I*>(input_);
    O* output = static_cast<O*>(output_);

    for (std::size_t i = 0; i < inputLenght; ++i) {
        output[i] = input[i] >= 0 ? input[i] : input[i] * static_cast<I>(std::get<0>(params));
    }
}

namespace {
static Registrar<ReLUImplForward_ref_cpp> registrarReLUImplForward_ref_cpp_Float32(
        {DataType::Float32, DataType::Float32}, Aidge::ReLUImpl_ref_cpp_forward_kernel<float, float>);
static Registrar<ReLUImplForward_ref_cpp> registrarReLUImplForward_ref_cpp_Int32(
        {DataType::Int32, DataType::Int32}, Aidge::ReLUImpl_ref_cpp_forward_kernel<int, int>);
static Registrar<ReLUImplForward_ref_cpp> registrarReLUImplForward_ref_cpp_Float64(
        {DataType::Float64, DataType::Float64}, Aidge::ReLUImpl_ref_cpp_forward_kernel<double, double>);
}  // namespace
}  // namespace Aidge

#endif /* ReLUImpl_ref_cpp_forward_kernel_H_ */
