
#include <cassert>
#include <numeric>
#include <vector>

#include "data/Tensor.hpp"
#include "operator/Producer.hpp"
#include "utils/Types.h"

#include "operator/ProducerImpl.hpp"

template<Aidge::DimIdx_t DIM>
std::size_t Aidge::ProducerImpl_ref_cpp<DIM>::getNbRequiredData(
    Aidge::IOIndex_t /*inputIdx*/) const
{
    return 0;
}

template<Aidge::DimIdx_t DIM>
Aidge::DimSize_t Aidge::ProducerImpl_ref_cpp<DIM>::getNbConsumedData(
    Aidge::IOIndex_t /*inputIdx*/) const
{
    return 0;
}

template<Aidge::DimIdx_t DIM>
std::size_t Aidge::ProducerImpl_ref_cpp<DIM>::getNbRequiredProtected(
    Aidge::IOIndex_t /*inputIdx*/) const
{
    return 0;
}

template<Aidge::DimIdx_t DIM>
std::size_t Aidge::ProducerImpl_ref_cpp<DIM>::getRequiredMemory(
    IOIndex_t outputIdx, const std::vector<DimSize_t> & /*inputsSize*/) const
{
    // Requires the whole tensors, regardless of available data on inputs
    assert(outputIdx == 0 && "operator has only one output");

    const auto &outputDims = std::static_pointer_cast<Tensor>(mOp.getOutput(0))->dims();
    return std::accumulate(
        outputDims.begin(),
        outputDims.end(),
        NbElts_t(1),
        std::multiplies<NbElts_t>());
}

template<Aidge::DimIdx_t DIM>
Aidge::DimSize_t Aidge::ProducerImpl_ref_cpp<DIM>::getNbProducedData(
    Aidge::IOIndex_t /*outputIdx*/) const
{
    return getRequiredMemory(0, {});
}

template<Aidge::DimIdx_t DIM> void Aidge::ProducerImpl_ref_cpp<DIM>::forward()
{
}

template<Aidge::DimIdx_t DIM> void Aidge::ProducerImpl_ref_cpp<DIM>::backward()
{
    printf("Not implemented yet.\n");
}