#include <iostream>
#include <map>
#include <memory>
#include <cassert>

#include <catch2/catch_test_macros.hpp>

#include "backend/OperatorImpl.hpp"
#include "graphmatching/NodeRegex.hpp"
#include "operator/GenericOperator.hpp"


using namespace Aidge;

TEST_CASE("Create Noderegex", "[Noderegex]") {
    std::shared_ptr<NodeRegex> nr = std::make_shared<NodeRegex>("conv");
}

TEST_CASE("Test _is function", "[Noderegex]") {
    // Create Noderegex with only condition on the name of the Node
    // Create several operators to pass into Noderegex _is function
    // Assert Noderegex._is(operators) are correct
    std::shared_ptr<NodeRegex> nr = std::make_shared<NodeRegex>("Conv");

    std::shared_ptr<Node> Conv = GenericOperator("Conv", 1, 1, 1);
    std::shared_ptr<Node> FC = GenericOperator("FC", 1, 1, 1);

    REQUIRE(nr->_is(Conv) == true);
    REQUIRE(nr->_is(FC) == false);
    REQUIRE(nr->isA("Conv") == true);
    REQUIRE(nr->isA("FC") == false);
    
}